/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoXliffUtilSplit]のクラス
 */
package blanco.xliff.util.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.xliff.util.task.valueobject.BlancoXliffUtilSplitProcessInput;

/**
 * Apache Antタスク [BlancoXliffUtilSplit]のクラス。
 *
 * [XLIFF対応ツール] 指定されたxliffファイルを指定件数毎に分割します。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.xliff.util.task]にBlancoXliffUtilSplitBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancoxliffutilsplit&quot; classname=&quot;blanco.xliff.util.task.BlancoXliffUtilSplitTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoXliffUtilSplitTask extends Task {
    /**
     * [XLIFF対応ツール] 指定されたxliffファイルを指定件数毎に分割します。
     */
    protected BlancoXliffUtilSplitProcessInput fInput = new BlancoXliffUtilSplitProcessInput();

    /**
     * [XLIFF対応ツール] 指定されたxliffファイルを指定件数毎に分割します。
     */
    protected boolean fIsFieldTargetdirProcessed = false;

    /**
     * [XLIFF対応ツール] 指定されたxliffファイルを指定件数毎に分割します。
     */
    protected boolean fIsFieldSourcefileProcessed = false;

    /**
     * [XLIFF対応ツール] 指定されたxliffファイルを指定件数毎に分割します。
     */
    protected boolean fIsFieldCountProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[targetdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * XLIFF (*.xlf) ファイルが出力されるディレクトリ。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetdir(final String arg) {
        fInput.setTargetdir(arg);
        fIsFieldTargetdirProcessed = true;
    }

    /**
     * Antタスクの[targetdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * XLIFF (*.xlf) ファイルが出力されるディレクトリ。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetdir() {
        return fInput.getTargetdir();
    }

    /**
     * Antタスクの[sourcefile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 入力対象の XLIFF (*.xlf) ファイル。<br>
     *
     * @param arg セットしたい値
     */
    public void setSourcefile(final String arg) {
        fInput.setSourcefile(arg);
        fIsFieldSourcefileProcessed = true;
    }

    /**
     * Antタスクの[sourcefile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 入力対象の XLIFF (*.xlf) ファイル。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getSourcefile() {
        return fInput.getSourcefile();
    }

    /**
     * Antタスクの[count]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * 分割する際の trans-unit の件数。<br>
     *
     * @param arg セットしたい値
     */
    public void setCount(final String arg) {
        try {
            fInput.setCount(Integer.parseInt(arg));
        } catch (NumberFormatException e) {
            throw new IllegalArgumentException("Antタスクの[count]アトリビュートに与えられた値の数値解析に失敗しました。" + e.toString());
        }
        fIsFieldCountProcessed = true;
    }

    /**
     * Antタスクの[count]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * 分割する際の trans-unit の件数。<br>
     * デフォルト値[50]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getCount() {
        return String.valueOf(fInput.getCount());
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoXliffUtilSplitTask begin.");

        // 項目番号[1]、アトリビュート[targetdir]は必須入力です。入力チェックを行います。
        if (fIsFieldTargetdirProcessed == false) {
            throw new BuildException("必須アトリビュート[targetdir]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[sourcefile]は必須入力です。入力チェックを行います。
        if (fIsFieldSourcefileProcessed == false) {
            throw new BuildException("必須アトリビュート[sourcefile]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- targetdir:[" + getTargetdir() + "]");
            System.out.println("- sourcefile:[" + getSourcefile() + "]");
            System.out.println("- count:[" + getCount() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoXliffUtilSplitProcessインタフェースを実装して blanco.xliff.util.taskパッケージに BlancoXliffUtilSplitProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoXliffUtilSplitProcess proc = new BlancoXliffUtilSplitProcessImpl();
            if (proc.execute(fInput) != BlancoXliffUtilSplitBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
